=== debian/changelog ===
spglib (2.4.0-1ubuntu1) oracular; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/p/fix-ruby3.2.patch: fix autopkgtest in ppc64el and s390x.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 21 Aug 2024 19:01:02 -0300

spglib (2.4.0-1) unstable; urgency=medium

  * New upstream version 2.4.0

 -- Andrius Merkys <merkys@debian.org>  Tue, 16 Apr 2024 05:00:40 -0400
