=== debian/changelog ===
spglib (2.5.0-2build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 19:41:23 +0000

spglib (2.5.0-2) unstable; urgency=medium

  [ Lucas Kanashiro ]
  * d/p/0003-Fix-autopkgtest-regression.patch: unblock ruby3.3 transition

  [ Andrius Merkys ]
  * Drop unused no-Python-tests.patch.
  * Bump copyright years.

 -- Andrius Merkys <merkys@debian.org>  Mon, 27 Jan 2025 10:32:34 -0500

spglib (2.5.0-1) unstable; urgency=medium

  * New upstream version 2.5.0
  * Build-depend on dh-sequence-numpy3.

 -- Andrius Merkys <merkys@debian.org>  Wed, 11 Sep 2024 05:06:18 -0400
